# 8.1

## Release Overview

**Release date:** 2022-09-22

### External Dependencies

This version of Naviga Writer has a number of external dependencies that need to be fulfilled before upgrading.

#### Dashboard Applications

* Writer plugin **≥ 5.1**
* Naviga Photos **≥ 3.0**
* Image Content Provider (ICP) **≥ 1.3.0**

## **Summary of changes**

* Writer notifications will now appear in Dashboard
* Content-menu UX updated
* Added opt-in support for global spellchecking service
* UI/UX improvements and fixes
* Developer API Updates

### Writer notifications will now appear in Dashboard

Notifications previously displayed in the Writer context will now appear as Dashboard notifications.

### Content-menu UX updated

The content menu has more choices on how to be displayed. Added a hierarchical setting viewing the different tools in submenus for both content objects and text styles.

The user can change this in Writer and the settings menu (top left icon) are stored in the browser meaning that the browser remembers what the user wants.

There is new writer config to change the default settings for a user opening writer in a new browser. Read about it below.

{% content-ref url="../admin-guide/configurations-guide/content-menu" %}
[content-menu](https://docs.navigaglobal.com/writer/8.1.6/admin-guide/configurations-guide/content-menu)
{% endcontent-ref %}

### Added opt-in support for global spellchecking service

A new property `"enableSaasSpellcheck"` has been added to the client configuration. Setting this to true will allow the Writer to use the new global spellchecking service. This configuration is opt-in for now, but a future major release will make this switch mandatory.

This new spellchecking service supports extending existing dictionaries with organisation specific wordlists, marking these words as correctly spelled in the Writer.

Documentation for integrating with an external spellcheck has been updated with configuration location and notice for cross-origin request.

{% content-ref url="../developer-guide/tutorials/integrating-external-spell-checking" %}
[integrating-external-spell-checking](https://docs.navigaglobal.com/writer/8.1.6/developer-guide/tutorials/integrating-external-spell-checking)
{% endcontent-ref %}

### Annotation tool

Taking ownership from substance to ease future development.

* Support for Naviga Content Icon Pack icons
* New icons for strong and emphasis
* Unavailable menu options will be displayed as disabled, instead of omitted
* Updated visuals

### UI/UX improvements and fixes

* Link plugin should no longer sometimes clear its input when link is created
* Copying and pasting multiple text nodes should now always retain their styles and annotations
* Improved support for Naviga Content Icon Pack icons.&#x20;
* New icons added (all available icons: <http://content-icon-pack.s3-website-eu-west-1.amazonaws.com/writer/8.1.0/>)

### Developer API Updates

#### AccessToken

NavigaID AccessToken containing all permissions the user is afforded by their current organisation and unit has been made available for plugin developers. The AccessToken is used to make requests to many of Naviga's services.

```typescript
// Getting an AccessToken in a plugin context
const accessToken = api.user.getAccessToken()
```

#### Sidebar

A new optional config property `alwaysMounted` has been added to the `extraTabConfig` parameter when register sidebar. Always mounted sidebars retain their state when switching between sidebars. Already registered sidebars will not be affected by this property.

Example

```javascript
export const PluginPackage = {
    name: 'im-internal-ui',
    id: 'io.infomaker.internal-ui',

    configure: function(configurator: DWConfigurator, pluginConfig: PluginConfiguration) {

        const extraTabConfig = {
            name: 'UI',
            shortName: 'UI,
            icon: 'professions-woman-magician-regular',
            alwaysMounted: true
        }

        // Add plugin to main sidebar (can be overriden in plugin config)
        configurator.addToSidebar('ui', pluginConfig, MainComponent, extraTabConfig)
    }
}
```

#### Annotation Tool Icon

Expanding config object for AnnotationTool to support icon for more convenient behavior. See [the iconpack for writer 8.1](http://content-icon-pack.s3-website-eu-west-1.amazonaws.com/writer/8.1.0/) for supported icons.

```typescript
config.addTool('strong', AnnotationTool, { 
    target: 'annotations', 
    icon: 'italic-text-bold'
})
```

#### Content Menu Hierarchical Group

In plugins when registering content menu top tool there is a new option to show the tool in specific submenus.

Example

```javascript
configurator.addLabel('content-menu-images', {
    sv: 'Bilder',
    en: 'Images',
})

configurator.addContentMenuTopTool('insert-images', InsertImagesTool, {
    group: 'content-menu-images'
})
```

#### New CSS Color Variables

New CSS color variables added for text on different backgrounds

* On dark
  * `dw-color-high-empahasis-on-dark`
  * `dw-color-medium-empahasis-on-dark`
  * `dw-color-low-empahasis-on-dark`
  * `dw-color-disabled-empahasis-on-dark`
* On light
  * `dw-color-high-empahasis-on-light`
  * `dw-color-medium-empahasis-on-light`
  * `dw-color-low-empahasis-on-light`
  * `dw-color-disabled-empahasis-on-light`

#### New `maxLength` property for UITextarea component

UITextarea introduces the new property `maxlength`. Constrains the number of characters and will prevent further input when length is reached.

```typescript
$$(UITextarea, {
    id: 'myTextarea',
    label: 'Max Length Test',
    placeholder: 'Textarea placeholder...',
    size: 'large',
    maxlength: 100,
    onChange: (value) => {
        // Do something
    }
}).ref('myTextarea')
```

## Updated Plugins

The following plugin's have been updated since last Naviga Writer release. Please use the [Writer Client Config Tool](https://plugins.writer.infomaker.io/upgrade-tool/) to upgrade your client configuration file.

* [im-link version 3.3.0](https://plugins.writer.infomaker.io/im-link/3.3.0)
  * Updated content-menu tool with new icon
* [im-inlinenotes version 2.1.0](https://plugins.writer.infomaker.io/im-inlinenotes/2.1.0)
  * Updated content-menu tool with new icon
* [im-articlevalidation version 1.1.0](https://plugins.writer.infomaker.io/im-articlevalidation/1.1.0/changelog)
  * Add ability to run/ignore rules for specific article subtypes, e.g. Print article
* [im-archivesearch version 3.1.0](https://plugins.writer.infomaker.io/im-archivesearch/3.1.0/changelog)
  * Display three items per row instead of four
  * Removed thumbnail in meta preview
  * Cleaned up and removed meta dialog. Now presented through Dashboard
* [im-conceptpublicationchannel version 2.2.0](https://plugins.writer.infomaker.io/im-conceptpublicationchannel/2.2.0/changelog)
  * Added ability to filter channels
* [im-articlehistory version 1.1.2](https://plugins.writer.infomaker.io/im-articlehistory/1.1.2/changelog)
  * Fixed sidebar full height bug
  * OC 2.6 requirement
  * Design fixes
  * Photos loading from restored version
  * Question about saving when restored version
* [im-charactertransformation version 1.2.0](https://plugins.writer.infomaker.io/im-charactertransformation/1.2.0/changelog)
  * Rules should be applied when typing a character with selected text
  * Correctly transform quotes when pasting text
* [im-aftercopy version 1.2.0](https://plugins.writer.infomaker.io/im-aftercopy/1.2.0/changelog)
  * Add ability to run/ignore rules for specific article subtypes, e.g. Print article
* [im-dashboard-integration version 4.0.2](https://plugins.writer.infomaker.io/im-dashboard-integration/4.0.2/changelog)
  * Fixed issue with imagegallery not being created when dropping multiple images from an Assignment
* [im-autoprint version 1.4.0](https://plugins.writer.infomaker.io/im-autoprint/1.4.0/changelog)
  * Disable plugin when editing article template
* [im-ncscontent version 1.8.0](https://plugins.writer.infomaker.io/im-ncscontent/1.8.0/changelog)
  * New UI to align with Naviga Writer
  * Present channel on version card
  * Added possibility to change publication status on new article
  * Disable plugin when editing article template
* [im-contentrelations version 3.1.0](https://plugins.writer.infomaker.io/im-contentrelations/3.1.0/changelog)
  * Added ability to hide `"tags"` from article cards
* [im-contentrelations version 2.2.2](https://plugins.writer.infomaker.io/im-contentrelations/2.2.2/changelog)
  * BACKPORT: Added ability to hide "tags" from article cards
* [im-articlename version 3.0.2](https://plugins.writer.infomaker.io/im-articlename/3.0.2/changelog)
  * Fix article name reverting to suggested value when clicking on the name input field directly after first save
* [im-publishflow version 2.6.2](https://plugins.writer.infomaker.io/im-publishflow/2.6.2/changelog)
  * Don't revert publication status when validation fails after article has already been successfully saved
  * Fixed crash when duplicating article with unsaved changes and clicking Cancel


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.navigaglobal.com/writer/8.1.6/release-notes/8.1-6.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
